<?php
/**
 * Profile Design 2.3
 * Copyright  2010 FrinkLabs, All Rights Reserved
 *
 * Website: http://frinklabs.xe.cx/
 */
 
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$plugins->add_hook("member_profile_start", "profiledesign_load_css");
$plugins->add_hook("admin_config_settings_change", "profiledesign_settings");
$plugins->add_hook('admin_user_groups_edit', 'profiledesign_admin_groups_edit');
$plugins->add_hook('admin_user_groups_edit_commit', 'profiledesign_admin_groups_edit_commit');

function profiledesign_info()
{	 
	global $lang;
	 
	$lang->load("profiledesign");
	 
	return array(
		"name"			=> $lang->pd_title,
		"description"	=> $lang->pd_description,
		"website"		=> "http://frinklabs.xe.cx/profiledesign",
		"author"		=> "frink<b>labs</b>",
		"authorsite"	=> "http://frinklabs.xe.cx/",
		"version"		=> "2.3.0",
		"guid" 			=> "f1e8677ff4513ffdfec79d6a5b4fe5bc",
		"compatibility" => "16*"
	);
}

function profiledesign_install() 
{
   global $db, $mybb, $cache;
   
   include MYBB_ROOT."/inc/adminfunctions_templates.php";
   
   $query = "CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."users_profiledesigns` (
   `pdid` int(11) NOT NULL AUTO_INCREMENT,
   `uid` int(11) NOT NULL,
   `bgcolor` varchar(7) NOT NULL,
   `borderstyle` varchar(20) NOT NULL,
   `bordersize` varchar(50) NOT NULL,
   `fontcolor` varchar(7) NOT NULL,
   `linkcolor` varchar(7) NOT NULL,
   `theadbgcolor` varchar(7) NOT NULL,
   `theadfontcolor` varchar(7) NOT NULL,
   `row1bgcolor` varchar(7) NOT NULL,
   `row2bgcolor` varchar(7) NOT NULL,
   `tableborderstyle` varchar(20) NOT NULL,
   `tablebordersize` varchar(50) NOT NULL,
   `tablebordercolor` varchar(7) NOT NULL,
   `innertablebordercolor` varchar(7) NOT NULL,
   `bgimage` varchar(120) NOT NULL,
   `bgimagerepeat` varchar(20) NOT NULL,
   `bordercolor` varchar(7) NOT NULL,
   PRIMARY KEY (`pdid`)
   );";
   
   $db->query($query);   

   $db->write_query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN(
		'enableprofiledesigns',
		'allowbgimages'
	)");
	
   $query = $db->query("SELECT COUNT(*) as rows FROM ".TABLE_PREFIX."settings WHERE gid = '9'");
   $rows = $db->fetch_field($query, "rows");
   
   $insertarray = array(
		'name' => 'enableprofiledesigns',
		'title' => 'Enable Profile Designs',
		'description' => 'If you activate this function, the users of your board can change the design of ther profile.',
		'optionscode' => 'yesno',
		'value' => '1',
		'disporder' => $rows+1,
		'gid' => '9'
	);
	
   $db->insert_query("settings", $insertarray);
	
   $insertarray = array(
		'name' => 'allowbgimages',
		'title' => 'Allow Background Images',
		'description' => 'If yes users can use background-images in their profile design.',
		'optionscode' => 'yesno',
		'value' => '0',
		'disporder' => $rows+2,
		'gid' => '9'
	);
	
   $db->insert_query("settings", $insertarray);
   
   rebuild_settings();
 
   
   $new = '{$headerinclude}
{$profiledesigncss}';
   
   find_replace_templatesets("member_profile", "#".preg_quote('{$headerinclude}')."#i", $new);
   
   $new = '{$header}
{$profiledesigneditor}
<div id="profile-container">';
   
   find_replace_templatesets("member_profile", "#".preg_quote('{$header}')."#i", $new);
   
   $new = '</div>
{$footer}';
   
   find_replace_templatesets("member_profile", "#".preg_quote('{$footer}')."#i", $new);

   $new = '<link rel="alternate" type="application/atom+xml" title="{$lang->latest_threads} (Atom 1.0)" href="{$mybb->settings[\'bburl\']}/syndication.php?type=atom1.0" />
<link rel="stylesheet" href="{$mybb->settings[\'bburl\']}/css/colorpicker.css" type="text/css" />';

   $old = '<link rel="alternate" type="application/atom+xml" title="{$lang->latest_threads} (Atom 1.0)" href="{$mybb->settings[\'bburl\']}/syndication.php?type=atom1.0" />';

   find_replace_templatesets("headerinclude", "#".preg_quote($old)."#i", $new);
   
   $new = '<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/popup_menu.js?ver=1400"></script>
<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/jquery.js"></script>
<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/colorpicker.js"></script>
<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/eye.js"></script>
<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/utils.js"></script>
<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/profiledesign.js"></script>';

   $old = '<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/popup_menu.js?ver=1400"></script>';
   
    find_replace_templatesets("headerinclude", "#".preg_quote($old)."#i", $new);
   
   $profiledesigneditor_template = '<form method="POST" action="{$mybb->settings[\'bburl\']}/member.php?action=profile&uid={$uid}">
<input type="hidden" name="save" value="pd">
<a class="float_right" id="style-profile-button" href="#"><img src="{$theme[\'imglangdir\']}/style.png" alt="{$lang->style}" title="{$lang->style}" /></a>
<br />
<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder" id="style-profile" style="display: none;">
<tr>
<td class="trow2">{$lang->bgcolor}</td>
<td class="trow2">{$lang->bgimage}</td>
<td class="trow2">{$lang->borderstyle}</td>
<td class="trow2">{$lang->bordersize}</td>
<td class="trow2">{$lang->bordercolor}</td>
</tr>
<tr>
<td class="trow1"><input style="width:98%;" id="pd-bgcolor" name="pd-bgcolor" autocomplete="off" value="{$profileCss[\'bgcolor\']}"></td>
<td class="trow1"><input style="width:98%;" id="pd-bgimage" name="pd-bgimage" autocomplete="off" value="{$profileCss[\'bgimage\']}"{$readonly}></td>
<td class="trow1">
<select style="width:98%;" id="pd-borderstyle" name="pd-borderstyle" size="1">
{$borderStyleSelect}
</select>
</td>
<td class="trow1">
<select style="width:98%;" id="pd-bordersize" name="pd-bordersize" size="1">
{$borderSizeSelect}
</select>
</td>
<td class="trow1"><input style="width:98%;" id="pd-bordercolor" name="pd-bordercolor" autocomplete="off" value="{$profileCss[\'bordercolor\']}"></td>
</tr>
<tr>
<td class="trow2">{$lang->fontcolor}</td>
<td class="trow2">{$lang->linkcolor}</td>
<td class="trow2">{$lang->theadbgcolor}</td>
<td class="trow2">{$lang->theadfontcolor}</td>
<td class="trow2">{$lang->row1bgcolor}</td>
</tr>
<tr>
<td class="trow1"><input style="width:98%;" id="pd-fontcolor" name="pd-fontcolor" autocomplete="off" value="{$profileCss[\'fontcolor\']}"></td>
<td class="trow1"><input style="width:98%;" id="pd-linkcolor" name="pd-linkcolor" autocomplete="off" value="{$profileCss[\'linkcolor\']}"></td>
<td class="trow1"><input style="width:98%;" id="pd-tableheadbgcolor" name="pd-tableheadbgcolor" autocomplete="off" value="{$profileCss[\'theadbgcolor\']}"></td>
<td class="trow1"><input style="width:98%;" id="pd-tableheadfontcolor" name="pd-tableheadfontcolor" autocomplete="off" value="{$profileCss[\'theadfontcolor\']}"></td>
<td class="trow1"><input style="width:98%;" id="pd-row1bgcolor" name="pd-row1bgcolor" autocomplete="off" value="{$profileCss[\'row1bgcolor\']}"></td>
</tr>
<tr>
<td class="trow2">{$lang->row2bgcolor}</td>
<td class="trow2">{$lang->tableborderstyle}</td>
<td class="trow2">{$lang->tablebordersize}</td>
<td class="trow2">{$lang->tablebordercolor}</td>
<td class="trow2">{$lang->innertablebordercolor}</td>
</tr>
<tr>
<td class="trow1"><input style="width:98%;" id="pd-row2bgcolor" name="pd-row2bgcolor" autocomplete="off" value="{$profileCss[\'row2bgcolor\']}"></td>
<td class="trow1">
<select style="width:98%;" id="pd-tableborderstyle" name="pd-tableborderstyle" size="1">
{$tableBorderStyleSelect}
</select>
</td>
<td class="trow1">
<select style="width:98%;" id="pd-tablebordersize" name="pd-tablebordersize" size="1">
{$tableBorderSizeSelect}
</select>
</td>
<td class="trow1"><input style="width:98%;" id="pd-tablebordercolor" name="pd-tablebordercolor" autocomplete="off" value="{$profileCss[\'tablebordercolor\']}"></td>
<td class="trow1"><input style="width:98%;" id="pd-innertablebordercolor" name="pd-innertablebordercolor" autocomplete="off" value="{$profileCss[\'innertablebordercolor\']}"></td>
</tr>
<tr>
<td class="trow2" align="right" colspan="5"><input type="reset" value="{$lang->reset}"><input type="submit" value="{$lang->save}"></td>
</tr>
</table>
</form>
<br />';

	$insert_array = array(
		'title' => 'profiledesigneditor',
		'template' => $db->escape_string($profiledesigneditor_template),
		'sid' => '-1',
		'version' => '',
		'dateline' => TIME_NOW
	);
	
	$db->insert_query("templates", $insert_array);
	
	$profiledesigncss_template = '<style>

  #profile-container {
    padding: 5px;
    background:#{$profileCss[\'bgcolor\']};
    background-image:url({$profileCss[\'bgimage\']});
    border-color:#{$profileCss[\'bordercolor\']};
    border-style:{$profileCss[\'borderstyle\']};
    border-width:{$profileCss[\'bordersize\']};
  }

  #profile-container a:link, #profile-container a:active, #profile-container a:visited, #profile-container a:hover {
    color:#{$profileCss[\'linkcolor\']};
  }

  #profile-container .tborder {
    background:#{$profileCss[\'innertablebordercolor\']};
    border-color:#{$profileCss[\'tablebordercolor\']};
    border-style:{$profileCss[\'tableborderstyle\']};
    border-width:{$profileCss[\'tablebordersize\']};
  }

  #profile-container .thead {
    color:#{$profileCss[\'theadfontcolor\']};
    background:#{$profileCss[\'theadbgcolor\']};
  }

  #profile-container .trow1 {
    color:#{$profileCss[\'fontcolor\']};
    background:#{$profileCss[\'row1bgcolor\']};
  }

  #profile-container .trow2 {
    color:#{$profileCss[\'fontcolor\']};
    background:#{$profileCss[\'row2bgcolor\']};
  }

</style>';
	
    $insert_array = array(
		'title' => 'profiledesigncss',
		'template' => $db->escape_string($profiledesigncss_template),
		'sid' => '-1',
		'version' => '',
		'dateline' => TIME_NOW
	);
	
	$db->insert_query("templates", $insert_array);
	
    $db->write_query("ALTER TABLE `".TABLE_PREFIX."usergroups` ADD `can_edit_profiledesign` int(1) unsigned NOT NULL default '1'");
    $db->write_query("ALTER TABLE `".TABLE_PREFIX."usergroups` ADD `can_use_bgimage` int(1) unsigned NOT NULL default '0'");
	
	$updated_perms = array(
		'can_edit_profiledesign'		=> 0
	);
	
	$db->update_query('usergroups', $updated_perms, "gid IN (1,7)");
	
	$updated_perms = array(
		'can_use_bgimage'		=> 1
	);
	
	$db->update_query('usergroups', $updated_perms, "gid IN (3,4,6)");

    $cache->update_usergroups();	
}

function profiledesign_is_installed() 
{
    global $db;
	
	if($db->table_exists("users_profiledesigns"))
	{	
	    return true;	
	}

	return false;	
}

function profiledesign_uninstall() 
{
    global $db, $mybb, $cache;
	
    include MYBB_ROOT."/inc/adminfunctions_templates.php";
	
	$db->query("drop table if exists ".TABLE_PREFIX."users_profiledesigns");   
	
	$db->write_query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN(
		'enableprofiledesigns',
		'allowbgimages'
	)");
	
    rebuild_settings();
	
    $old = '{$headerinclude}
{$profiledesigncss}';
   
    find_replace_templatesets("member_profile", "#".preg_quote($old)."#i", '{$headerinclude}', 0);
   
    $old = '{$header}
{$profiledesigneditor}
<div id="profile-container">';
   
    find_replace_templatesets("member_profile", "#".preg_quote($old)."#i", '{$header}', 0);
   
   
    $old = '</div>
{$footer}';
   
    find_replace_templatesets("member_profile", "#".preg_quote($old)."#i", '{$footer}', 0);

   $old = '<link rel="alternate" type="application/atom+xml" title="{$lang->latest_threads} (Atom 1.0)" href="{$mybb->settings[\'bburl\']}/syndication.php?type=atom1.0" />
<link rel="stylesheet" href="{$mybb->settings[\'bburl\']}/css/colorpicker.css" type="text/css" />';

   $new = '<link rel="alternate" type="application/atom+xml" title="{$lang->latest_threads} (Atom 1.0)" href="{$mybb->settings[\'bburl\']}/syndication.php?type=atom1.0" />';

   find_replace_templatesets("headerinclude", "#".preg_quote($old)."#i", $new, 0);
   
   $old = '<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/popup_menu.js?ver=1400"></script>
<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/jquery.js"></script>
<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/colorpicker.js"></script>
<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/eye.js"></script>
<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/utils.js"></script>
<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/profiledesign.js"></script>';

   $new = '<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/jscripts/popup_menu.js?ver=1400"></script>';
   
   find_replace_templatesets("headerinclude", "#".preg_quote($old)."#i", $new, 0);
	
   $db->delete_query("templates", "title = 'profiledesigneditor'");
	
   $db->delete_query("templates", "title = 'profiledesigncss'");
   
   $db->write_query("ALTER TABLE `".TABLE_PREFIX."usergroups` DROP `can_edit_profiledesign`");	 
   $db->write_query("ALTER TABLE `".TABLE_PREFIX."usergroups` DROP `can_use_bgimage`");	 
   
   $cache->update_usergroups();	
}

function profiledesign_load_css()
{	
	global $mybb, $theme, $db, $templates, $lang, $uid, $readonly, $profileCss, $borderStyleSelect, $tableBorderStyleSelect, $borderSizeSelect, $tableBorderSizeSelect, $profiledesigncss, $profiledesigneditor;
	
	$lang->load("profiledesign");
	
	$uid = $mybb->input['uid'];
	
	$query = $db->query("SELECT * FROM ".TABLE_PREFIX."users_profiledesigns WHERE uid = '".$mybb->input['uid']."' LIMIT 1");      
    
	if (!$query->num_rows) 
	{	   
	   $query = array("uid" => $mybb->input['uid']);
	
	   $db->insert_query("users_profiledesigns", $query);	
	   
	   $query = $db->query("SELECT * FROM ".TABLE_PREFIX."users_profiledesigns WHERE uid = '".$mybb->input['uid']."' LIMIT 1");      
    }
	
	$profileCss = $db->fetch_array($query);   

	$borderStyles = array(
	   "none" => "No Border",
	   "dotted" => "Dotted",
	   "dashed" => "Dashed",
	   "solid" => "Solid",
	   "double" => "Double",
	   "groove" => "3D (Groove)",
	   "ridge" => "3D (Ridge)",
	   "inset" => "3D (Inset)",
	   "outset" => "3D (Outset)",
	);
	   
    foreach ($borderStyles AS $style => $styleName) 
	{	   
	    if($profileCss['borderstyle'] == $style)
	    {		  
		   $selected = " selected";		  
	    }
	    else
		{
		   $selected = "";		  
		}
		  
	    $borderStyleSelect .= "<option value=\"".$style."\"".$selected.">".$lang->$style."</option>\n";	   
	}
	   
    if(empty($profileCss['tableborderstyle'])) 
	{	   
	    $profileCss['tableborderstyle'] = "solid";	   
	}
	   
	foreach ($borderStyles AS $style => $styleName) 
	{	   
	    if($profileCss['tableborderstyle'] == $style)
	    {		  
		   $selected = " selected";		  
	    }
		else
		{
		   $selected = "";		  
		}	
		  
	    $tableBorderStyleSelect .= "<option value=\"".$style."\"".$selected.">".$lang->$style."</option>\n";	   
	}
	   
	$borderSizes = array(
	   "thin" => "Thin",
	   "medium" => "Medium",
	   "thick" => "Thick",
	   "10px" => "Very Thick",
	   "20px" => "Very Very Thick",
	   "30px" => "Very Very Very Thick"
	);
	   
	foreach ($borderSizes AS $size => $sizeName) 
	{	   
	   if($profileCss['bordersize'] == $size)
	   {		  
		  $selected = " selected";		  
	   }
	   else
	   {
		  $selected = "";		  
	   }	
	   
	   $borderSizeSelect .= "<option value=\"".$size."\"".$selected.">".$lang->$size."</option>\n";	   
	}
	   
	foreach ($borderSizes AS $size => $sizeName) 
	{	   
	    if($profileCss['tablebordersize'] == $size)
		{		  
		   $selected = " selected";		  
		}
		else
		{
		   $selected = "";		  
		}	
		
	    $tableBorderSizeSelect .= "<option value=\"".$size."\"".$selected.">".$lang->$size."</option>\n";	   
	}
	   
	if($mybb->settings['allowbgimages'] == "0" AND $mybb->usergroup['can_use_bgimage'] == 0)
	{	   
	    $readonly = " readonly";
	    $profileCss['bgimage'] = '';	   
	}		
	
	if($mybb->input['save'] == "pd")
	{	
	   	$updateArray = array(
          "bgcolor" => $db->escape_string($mybb->input['pd-bgcolor']),
          "bgimage" => $db->escape_string($mybb->input['pd-bgimage']),
          "borderstyle" => $db->escape_string($mybb->input['pd-borderstyle']),
          "bordersize" => $db->escape_string($mybb->input['pd-bordersize']),
          "bordercolor" => $db->escape_string($mybb->input['pd-bordercolor']),
          "fontcolor" => $db->escape_string($mybb->input['pd-fontcolor']),
          "linkcolor" => $db->escape_string($mybb->input['pd-linkcolor']),
          "theadbgcolor" => $db->escape_string($mybb->input['pd-tableheadbgcolor']),
          "theadfontcolor" => $db->escape_string($mybb->input['pd-tableheadfontcolor']),
          "row1bgcolor" => $db->escape_string($mybb->input['pd-row1bgcolor']),
          "row2bgcolor" => $db->escape_string($mybb->input['pd-row2bgcolor']),
          "tableborderstyle" => $db->escape_string($mybb->input['pd-tableborderstyle']),
          "tablebordersize" => $db->escape_string($mybb->input['pd-tablebordersize']),
          "tablebordercolor" => $db->escape_string($mybb->input['pd-tablebordercolor']),
          "innertablebordercolor" => $db->escape_string($mybb->input['pd-innertablebordercolor'])
	    );
	
	    if($mybb->input['uid'] == $mybb->user['uid'] AND $mybb->usergroup['can_edit_profiledesign'] == 1) 
	    { 	
	       if($db->update_query("users_profiledesigns", $updateArray, "uid='".$mybb->user['uid']."'")) 
		   {		
		       $profile_link = $mybb->settings['bburl'].'/member.php?action=profile&uid='.$mybb->user['uid'];

		       redirect($profile_link, $lang->redirect);
		   }  	
	    }		
    }
	
	if($mybb->settings['enableprofiledesigns'] == "1")
	{	
	   eval("\$profiledesigncss= \"".$templates->get("profiledesigncss")."\";");	
	   
	   if($mybb->input['uid'] == $mybb->user['uid'] AND $mybb->usergroup['can_edit_profiledesign'] == 1) 
	   {	   
	       eval("\$profiledesigneditor= \"".$templates->get("profiledesigneditor")."\";");		   
	   }
	}	
}

function profiledesign_settings()
{
    global $lang;

    $lang->load("profiledesign");
}

function profiledesign_admin_groups_edit()
{
	global $plugins;

	$plugins->add_hook('admin_formcontainer_end', 'profiledesign_admin_groups_edit_end');
}

function profiledesign_admin_groups_edit_end()
{
	global $mybb, $lang, $form, $form_container;

	$lang->load('profiledesign');
	
	if($form_container->_title == $lang->users_permissions)
	{	
		if($mybb->input['gid'] != 1)
		{	
		   $profiledesigns_options = array();
		   $profiledesigns_options[] = $form->generate_check_box('can_edit_profiledesign', 1, $lang->can_edit_profiledesign, array('checked' => $mybb->input['can_edit_profiledesign']));
		   $profiledesigns_options[] = $form->generate_check_box('can_use_bgimage', 1, $lang->can_use_bgimage, array('checked' => $mybb->input['can_use_bgimage']));
		
		   $form_container->output_row($lang->profiledesign, '', '<div class="group_settings_bit">'.implode('</div><div class="group_settings_bit">', $profiledesigns_options).'</div>');		
		}		
	}
}

function profiledesign_admin_groups_edit_commit()
{
	global $mybb, $updated_group;

	$updated_group['can_edit_profiledesign'] = intval($mybb->input['can_edit_profiledesign']);
	$updated_group['can_use_bgimage'] = intval($mybb->input['can_use_bgimage']);
}

?>